import { AnyFn } from '@rhao/types-base';
import { HookContext, ExecutionStage } from './Context';
import { HookKeys } from './types';
export declare class ContextHelper {
    static create: (name: string, args: any[], length: number) => HookContext;
    static get: <HT extends Record<string, any>, HN extends HookKeys<HT>>() => HookContext<HT[HN]> | null;
    static set: (ctx: HookContext) => HookContext<AnyFn>;
    static drop: () => void;
    static with: <T extends AnyFn>(fn: T, ctx: HookContext, index: number) => T;
    static updateStage: (ctx: HookContext, stage: ExecutionStage) => void;
    static updateCurrentIndex: (ctx: HookContext, index: number) => void;
}
