var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
import { ExecutionStage } from "./Context.js";
let currentContext = null;
const _ContextHelper = class _ContextHelper {
};
__publicField(_ContextHelper, "create", (name, args, length) => {
  return {
    name,
    args,
    length,
    currentIndex: -1,
    stage: ExecutionStage.init
  };
});
__publicField(_ContextHelper, "get", () => {
  return currentContext;
});
__publicField(_ContextHelper, "set", (ctx) => {
  currentContext = ctx;
  return ctx;
});
__publicField(_ContextHelper, "drop", () => {
  currentContext = null;
});
__publicField(_ContextHelper, "with", (fn, ctx, index) => {
  let _fn = (...args) => {
    _fn = null;
    try {
      _ContextHelper.set(ctx);
      _ContextHelper.updateCurrentIndex(ctx, index);
      const result = fn(...args);
      if (result instanceof Promise) {
        result.then((value) => {
          ctx.returned = value;
        });
      } else {
        ctx.returned = result;
      }
      return result;
    } finally {
      _ContextHelper.drop();
    }
  };
  return _fn;
});
__publicField(_ContextHelper, "updateStage", (ctx, stage) => {
  Object.assign(ctx, { stage });
});
__publicField(_ContextHelper, "updateCurrentIndex", (ctx, index) => {
  Object.assign(ctx, {
    currentIndex: index,
    isFirst: index === 0,
    isEnd: index === ctx.length - 1
  });
});
let ContextHelper = _ContextHelper;
export {
  ContextHelper
};
//# sourceMappingURL=ContextHelper.js.map
