import { AnyFn } from '@rhao/types-base';
import { HookCallback, HookKeys } from './types';
export type HookTaskCaller<HN extends HookKeys<any> = string, Args extends any[] = unknown[]> = (name: HN, hooks: HookCallback[], args: Args) => any;
/**
 * 执行策略
 */
export declare enum CallStrategy {
    /** 同步执行任务，并返回最终结果 */
    Sync = 0,
    /** 异步串行执行任务，并返回最终结果 */
    AsyncSerial = 1,
    /** 异步并行执行任务，并返回所有任务结果 */
    AsyncParallel = 2
}
/**
 * 执行策略实现
 */
export declare const CALL_STRATEGY: Record<CallStrategy, (tasks: AnyFn[]) => AnyFn>;
export declare function createCaller(strategy: CallStrategy): HookTaskCaller;
export declare const syncTaskCaller: HookTaskCaller<string, unknown[]>;
export declare const serialTaskCaller: HookTaskCaller<string, unknown[]>;
export declare const parallelTaskCaller: HookTaskCaller<string, unknown[]>;
