import { Hookable } from './Hookable';
export interface CreateDebuggerOptions {
    /** An optional tag to prefix console logs with */
    tag?: string;
    /**
     * Show hook params to the console output
     *
     * Enabled for browsers by default
     */
    inspect?: boolean;
    /**
     * Use group/groupEnd wrapper around logs happening during a specific hook
     *
     * Enabled for browsers by default
     */
    group?: boolean;
    /** Filter which hooks to enable debugger for. Can be a string prefix or fn. */
    filter?: string | ((event: string) => boolean);
}
/** Start debugging hook names and timing in console */
export declare function createDebugger(hooks: Hookable<any>, _options?: CreateDebuggerOptions): {
    /** Stop debugging and remove listeners */
    close: () => void;
};
